<?php

# zet de benodigde scripts in de wachtrij
function unumba_loadscripts() {
	
	# plaats alle afhankelijkheden, inclusief jQuery, in de reeks
	wp_register_script('unumba-script', UNUMBA_PLUGIN_JS_DIR . 'unumba.js', array('jquery'), '1.0.0', true);
	wp_enqueue_script('unumba-script');
	wp_register_style('unumba-style', UNUMBA_PLUGIN_CSS_DIR . 'unumba.css', array(), '1.0.0', "all");
	wp_enqueue_style('unumba-style');
}

function unumba_get_bid($chatbot) {
	
	$chatbot = trim(strtolower($chatbot));
	
	switch($chatbot) {
		case 'unumba':
			$bid = 1;
			break;
		default:
			$bid = 1;
			break;
	}
	return $bid;
}

function unumba_create_gid() {
	
	$gid = $_SERVER['SERVER_NAME'] . date("ymdhis") . rand();
	$gid = preg_replace('/[^\da-z]/i', '-', $gid);
	return $gid;
}

function unumba_get_gid() {
	return $_COOKIE['unumba_id'];
}

function register_unumba_shortcodes() {
	add_shortcode('unumba-chat', 'unumba_showhtml');
}

function unumba_showhtml($code) {
	extract(shortcode_atts(array(
		'width' => 'auto',
		'height' => 400,
		'chatbot'=> 'unumba',
		'showlink'=> 0,
	), $code, 'unumba-chat'));
	return unumba_chatform($chatbot, $width, $height, $showlink);
}

function unumba_chatbot_function($chatbot=1, $width=600, $height=300, $showlink=0) {
	echo unumba_chatform($chatbot, $width, $height, $showlink);
}

function unumba_chatform($chatbot, $width, $height, $unumba_link = 0) {
	
	# verkrijg de breedte en hoogte
	if (strpos($width, '%') !== false) {
		$formwidth = ($width - 25) .'%'; $width = (int) filter_var($width, FILTER_SANITIZE_NUMBER_INT).'%';
	} else {
		if ($width != 'auto') {$formwidth = $width - 50; $width = (int) filter_var($width, FILTER_SANITIZE_NUMBER_INT).'px'; }
	}
	if (strpos($height, '%') !== false) {
		$height = (int) filter_var($height, FILTER_SANITIZE_NUMBER_INT).'%';
	} else {
		if ($height != 'auto') { $height = (int) filter_var($height, FILTER_SANITIZE_NUMBER_INT).'px'; }
	}
	if ($width == 0) { $width = 'auto'; } if ($height == 0) { $height = '400px'; }
	if ($width == 'auto') { $formwidth = '75%'; }
	
	$botnaam = botnaam();
	
	if (isset($_COOKIE[unumba_gesprek])) {
		$gesprekslog = $_COOKIE[unumba_gesprek];
	} else {
		$gesprekslog = "";
	}
	
	$gesprekslog = urldecode(stripslashes($gesprekslog));
	# urldecode: '%5B'='[', '%7C'='|', '%5D'=']', '%3A'=':', '%20'=' ', '%3F'='?';
	$gesprekslog = str_replace(array('[','|',']'),array('<div class="invoer">','</div><div class="uitvoer">','</div>'), $gesprekslog);
	$bid = unumba_get_bid($chatbot);
	
	$html = "<div class='unumba-post'><script type='text/javascript'>botnaam = '".$botnaam."';</script>
	<div id='gesprek' style='height:" . $height . "; width:" . $width . ";'>".$gesprekslog."</div>
		<form id='unumbaform'>
			<input type='text' id='invoer' name='invoer' placeholder='Type hier je invoer' tabindex='1' style='width:".$formwidth.";' />
			<input type='hidden' id='gid' name='gid' value='". UNUMBAID ."' />
			<input type='hidden' id='bid' name='bid' value='" . $bid . "' />
			<input type='hidden' id='pluginpad' name='pluginpad' value='" . UNUMBA_PLUGIN_URL . "' />
			<input type='submit' id='submit' name='submit' tabindex='2' value='Zeg' />
		</form>
		<div class='unumbalinks'><a class='wisgesprek' href=''>Wis Gesprek</a>";
	if($unumba_link == 1) {
		$html .= " &nbsp; <a href='https://www.unumba.nl' target='_blank'>Bezoek Unumba.nl</a>";
	}
	$html .= "<span id='fout'></span></div></div>";
	
	return $html;
}

# page_title, menu_title, capability, menu_slug, function
function unumba_admin_menu() {
	add_options_page('Unumba', 'Unumba', 'manage_options', 'unumba_info', 'unumba_info');
}

function unumba_plugin_settings_link($links) : array {
	$label = esc_html__('Settings', 'unumba');
	$slug	= 'unumba_info';
	
	array_unshift($links, "<a href='options-general.php?page=$slug'>$label</a>");
	
	return $links;
}

# unumba instellingen
function unumba_settings_init() {
	
	register_setting('pluginPage', 'unumba_settings');
	
	add_settings_section(
		'unumba_pluginPage_section', 
		__('Chatbot name','Unumba'), 
		'unumba_settings_section_callback', 
		'pluginPage'
	);
	
	add_settings_field(
		'unumba_text_field', 
		__('Enter name:','Unumba'), 
		'unumba_text_field_render', 
		'pluginPage', 
		'unumba_pluginPage_section'
	);
}

function unumba_text_field_render() {
	$options = get_option('unumba_settings');
?>
<input type='text' name='unumba_settings[unumba_text_field]' value='<?php echo $options['unumba_text_field']; ?>'>
<?php
}

function botnaam() {
	$options = get_option('unumba_settings');
	$botnaam = $options['unumba_text_field'];
	return $botnaam;
}

function unumba_settings_section_callback() {
	echo __('Give your chatbot it\'s own name.', 'Unumba');
}

# unumba info
function unumba_info() {
?>
<div class="wrap">
	<div id="icon-options-general" class="icon32"><br></div>
	<h2>Unumba Info</h2>
		<p>Thank you for using the Unumba Chatbot WordPress Plugin.</p>
		<p>This is a very small and simple plugin which has one shortcode and one widget.</p>
		<p>The shortcode is [unumba-chat] and you can specify the following parameters:
	<ul>
		<li>chatbot - the name of the bot to talk to</li>
		<li>width - the width of the chat window</li>
		<li>height - the height of the chat window</li>
		<li>showlink - adds a link to the bottom of the talk form to display a link to Unumba (1=show 0=don't show)</li>
	</ul>
	</p>
	<p>Width and height can be defined as 'auto' or in percentage (%). Without definition sizes are in pixels (px).</p>
	<p>So if you wanted to embed a chatwindow to talk to Unumba just add this shortcode <pre><code>[unumba-chat]</code></pre></p>
	<p>And if you wanted to embed a chatwindow to talk to Unumba with a width of 600px and height of 300px and including the link just add this shortcode <pre><code>[unumba-chat chatbot=unumba width=600 height=300 showlink=1]</code></pre>
	</p>
	<p>If you would like the function call to use inside your theme directly just use this piece of code:
		<pre><code>if (function_exists('unumba_chatbot_function')) {unumba_chatbot_function($chatbot, $width, $height, $showlink);}</code></pre>
		Or: <pre><code>if (function_exists('unumba_chatbot_function')) {unumba_chatbot_function();}</code></pre>
		With settings: <pre><code>if (function_exists('unumba_chatbot_function')) {unumba_chatbot_function('unumba', 600, 300, 1);}</code></pre>
	</p>
	<p>Without any parameters the default bot is Unumba.</p>
	<p>Please note that this chatbot only speaks Dutch!</p>
	<p>Links:
	<a href="https://www.unumba.nl" target="_blank">Unumba Website</a> ::
	<a href="https://www.loem.nl/projecten/unumba" target="_blank">Loem Project Site</a></p>
</div>
<form action='options.php' method='post'>
<?php
settings_fields('pluginPage');
do_settings_sections('pluginPage');
submit_button();
?>
</form>
<?php
}
?>