<?php

/*
Plugin Name: Unumba
Plugin Script: unumba.php
Plugin URI: https://www.loem.nl/projecten/unumba/
Description: Add Unumba to your WordPress site.
Version: v1.0
Author: Loem
Author URI: https://www.loem.nl/web

=== RELEASE NOTES ===
2021-03-21 - v1.0 - first version
License: GPL2 */
/* Copyright 2022 Loem (email : loem@loem.nl)
 This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License, version 2, as published by the Free Software Foundation.
 This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.
 You should have received a copy of the GNU General Public License along with this program;
 if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

define("UNUMBA_PLUGIN_DIR", __FILE__);
define("UNUMBA_PLUGIN_BASE", dirname(__FILE__));
define("UNUMBA_PLUGIN_URL", plugin_dir_url(UNUMBA_PLUGIN_DIR));

define("UNUMBA_PLUGIN_JS_DIR", UNUMBA_PLUGIN_URL."js/");
define("UNUMBA_PLUGIN_LIB_DIR", UNUMBA_PLUGIN_BASE . "/lib/");
define("UNUMBA_PLUGIN_CSS_DIR", UNUMBA_PLUGIN_URL . "styles/");

//define("UNUMBA_GESPREK", "UNUMBA_GESPREK");
//define("UNUMBA_ID", "UNUMBA_ID");

include_once(UNUMBA_PLUGIN_LIB_DIR . '/unumba_functions.php');

add_action('init', 'register_unumba_shortcodes');
add_action('admin_menu', 'unumba_admin_menu');
add_action('admin_init', 'unumba_settings_init');
add_action('wp_enqueue_scripts', 'unumba_loadscripts');
add_action('init', 'unumba_gid_init');
add_action('plugin_action_links_' . plugin_basename( __FILE__ ), 'unumba_plugin_settings_link', 10 );

function unumba_gid_init(){
	define("UNUMBAID", unumba_create_gid());
}

?>